﻿//css_ref System.Data;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;

using System;
using System.Transactions;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.Providers;

namespace AddUserFieldsAndUserQueries
{
    class Program
    {
        //All most all user defined fields(UDF) can be added manual except these 2. Therefor this script can be used for doing that

        public static string CONNECTION_STRING = "Server=localhost;CompanyDB=SBODemo_US;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2005;DBCultureInfo=en-US;LicenseServer=localhost:30000;ExtraDb=PMX_SBODemo_US";
        //const string CONNECTION_STRING = "Server=localhost;CompanyDB=IMPERMO_BE_IMPORT;UseTrusted=False;DbUserName=sa;DbPassword=dihbwwei963;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2008;DBCultureInfo=en-US;LicenseServer=localhost:30000;ExtraDb=PMX_IMPERMO_BE_IMPORT";

        static void Main(string[] args)
        {
            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (SboConnection conn = new SboConnection(CONNECTION_STRING))
                {
                    conn.Open(); //Open connection to SAP
                    Console.WriteLine("Connection is open to database");

                    SboUserFieldMDProvider udfProv = new SboUserFieldMDProvider(conn);

                    // Add UDF to Business Partners
                    udfProv.AddUpdateUserfield("OCRD", new SboColumnDefinitionAttribute("CustNum", "Klantennummer", SboFieldType.Alpha, 10, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OCRD", new SboColumnDefinitionAttribute("DelDay2", "2de leveringsdag", SboFieldType.Alpha, 10, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OCRD", new SboColumnDefinitionAttribute("PrefCom", "Communicatie via", SboFieldType.Alpha, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OCRD", new SboColumnDefinitionAttribute("Acquaint", "Leren kennen via", SboFieldType.Alpha, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OCRD", new SboColumnDefinitionAttribute("PrefCom", "Communicatie via", SboFieldType.Alpha, 8, SboFieldSubType.None));


                    // End adding UDF to Business Partners

                    // start adding UDF to item master Data

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitFaBL1", "Titel facturatiebijlage 1", SboFieldType.Memo, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitFaBL2", "Titel facturatiebijlage 2", SboFieldType.Memo, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitFaBL3", "Titel facturatiebijlage 3", SboFieldType.Memo, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitFaBL4", "Titel facturatiebijlage 4", SboFieldType.Memo, 8, SboFieldSubType.None));

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitLeg1", "Titel legpatroon 1", SboFieldType.Memo, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitLeg2", "Titel legpatroon 2", SboFieldType.Memo, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitLeg3", "Titel legpatroon 3", SboFieldType.Memo, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("TitLeg4", "Titel legpatroon 4", SboFieldType.Memo, 8, SboFieldSubType.None));

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("VastOpm", "Vaste opmerking per artikel", SboFieldType.Memo, 8, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Hardheid", "Hardheid", SboFieldType.Alpha, 20, SboFieldSubType.None));

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("BLFact1", "Bijlage bij factuur 1", SboFieldType.Memo, 250, SboFieldSubType.Link));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("BLFact2", "Bijlage bij factuur 2", SboFieldType.Memo, 250, SboFieldSubType.Link));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("BLFact3", "Bijlage bij factuur 3", SboFieldType.Memo, 250, SboFieldSubType.Link));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("BLFact4", "Bijlage bij factuur 4", SboFieldType.Memo, 250, SboFieldSubType.Link));

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Legpat1", "Legpatroon 1", SboFieldType.Memo, 250, SboFieldSubType.Link));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Legpat2", "Legpatroon 2", SboFieldType.Memo, 250, SboFieldSubType.Link));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Legpat3", "Legpatroon 3", SboFieldType.Memo, 250, SboFieldSubType.Link));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Legpat4", "Legpatroon 4", SboFieldType.Memo, 250, SboFieldSubType.Link));

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("OrgArt", "Oorspronkelijk artikelnummer", SboFieldType.Alpha, 20, SboFieldSubType.None));
                    //dit is om de controle uit te voeren als origineel artikelcode is aangepast
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("OrgArtC", "Oorspronkelijk artikelnummer (controle)", SboFieldType.Alpha, 20, SboFieldSubType.None));

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs1", "Prijs 1 - Aanb vkp ex btw", SboFieldType.Float, 4, SboFieldSubType.Price));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs2", "Prijs 2 - Geaff tnz ex btw ", SboFieldType.Float, 4, SboFieldSubType.Price));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs3", "Prijs 3 - Net ikp ex btw", SboFieldType.Float, 4, SboFieldSubType.Price));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs4", "Prijs 4 – Beursprijs", SboFieldType.Float, 4, SboFieldSubType.Price));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs5", "Prijs 5 - Soldenprijs", SboFieldType.Float, 4, SboFieldSubType.Price));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("LastPric", "Laatste aankoopprijs", SboFieldType.Float, 4, SboFieldSubType.Price));


                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("LocToon", "Locatie Toonzaal", SboFieldType.Alpha, 30, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("LocSample", "Locatie stalen", SboFieldType.Alpha, 30, SboFieldSubType.None));


                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("OrgArtOk", "Origineel art", SboFieldType.Alpha, 1, SboFieldSubType.None));


                    SboColumnDefinitionAttribute OrgArtOK = new SboColumnDefinitionAttribute("OrgArtOk", "Origineel Artikel Check", SboFieldType.Alpha, 1, SboFieldSubType.None);
                    // boolColumnDef.SboBOColumnConverterType = typeof(SboBooleanConvertor);
                    OrgArtOK.DefaultValue = "1";
                    udfProv.AddUpdateUserfield("OITM", OrgArtOK);

                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("LastDat", "Prijs 1 - Laatste aankoopdatum", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs1Date", "Prijs 1 - Laatste update", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs2Date", "Prijs 2 - Laatste update", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs3Date", "Prijs 3 - Laatste update", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs4Date", "Prijs 4 - Laatste update", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs5Date", "Prijs 5 - Laatste update", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs5DateF", "Prijs 5 - geldig vanaf", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("Prijs5DateT", "Prijs 5 - geldig tot", SboFieldType.Date, 4, SboFieldSubType.None));


                    // End adding UDF to item master data

                    // Start adding UDF to document headers
                    udfProv.AddUpdateUserfield("ORDR", new SboColumnDefinitionAttribute("plandate", "Vast afgespr lev-afh datum", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("ORDR", new SboColumnDefinitionAttribute("estdate", "Geschatte leveringdatum", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("ORDR", new SboColumnDefinitionAttribute("OpItms", "Document print", SboFieldType.Numeric, 1, SboFieldSubType.None));
		    		udfProv.AddUpdateUserfield("ORDR", new SboColumnDefinitionAttribute("Payadva", "Betaald voorschot", SboFieldType.Float, 1, SboFieldSubType.Price));
	

                    // End adding UDF to document headers


                    // Start adding UDF to document lines

                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("BvAantal", "Bevestigd aantal", SboFieldType.Float, 1, SboFieldSubType.Quantity));
                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("BvNum", "Bevestigingsnummer", SboFieldType.Numeric, 10, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("BvDat", "Bevestigingsdatum", SboFieldType.Date, 4, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("ppvkpe", "prijs per verkoopeenheid", SboFieldType.Float, 4, SboFieldSubType.Sum));
                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("SecOms", "Tweede omschrijving", SboFieldType.Alpha, 50, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("stocksu", "Stock in vkeh", SboFieldType.Float, 1, SboFieldSubType.Quantity));
                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("OrgArt", "Oud artikelnummer", SboFieldType.Alpha, 20, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("GLLOCALNAME", "Grootboek Naam", SboFieldType.Alpha, 100, SboFieldSubType.None));



                    // End adding UDF to document lines


                    //Add culture name to user language
                    //     udfProv.AddUpdateUserfield("OLNG", new SboColumnDefinitionAttribute("PMX_CULT", "Culture name", SboFieldType.Alpha, 20, SboFieldSubType.None));

                    //Add automatic shipping to Shipping types
                    //  SboColumnDefinitionAttribute boolColumnDef = new SboColumnDefinitionAttribute("PMX_AUSH", "Automatic shipping?", SboFieldType.Alpha, 1, SboFieldSubType.None);
                    //  boolColumnDef.SboBOColumnConverterType = typeof(SboBooleanConvertor);
                    //  boolColumnDef.DefaultValue = "N";
                    //  udfProv.AddUpdateUserfield("OSHP", boolColumnDef);

                }

                //Complete transaction
                scope.Complete();

            }
        }
    }
}
